<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 10 $
 * $Author: PragmaMx $
 * $Date: 2018-09-30 15:43:26 +0200 (So, 30. Sep 2018) $
 */
 
defined('mxMainFileLoaded') or die('access denied');




/***
* stcSaveSettings($pvs)
* 
***/
function stcSaveSettings($post){
	global $prefix, $module_name;
	
	$config = load_class('Config',$module_name);
	
	$pvs = mxAddSlashesForSQL($post);
	extract($pvs);
	
	// zur Sicherheit	
	if(empty($upload_width)){
		include_once(PMX_MODULES_DIR . DS . $module_name . DS . "includes/default_config.php");	
		$default_config = defaultConfig();
		$upload_width = $default_config['upload_width'];
	}	
	// !Bookmark vars auf Zahlen prüfen	
	$config_now['show_name'] = $show_name;
	$config_now['show_before'] = $show_before;
	$config_now['show_design'] = $show_design;
	$config_now['upload_path'] = $upload_path;
	$config_now['upload_width'] = $upload_width;
	$config_now['show_empty_lines'] = 1;
	$config_now['upload_hight'] = $upload_hight;
	$config_now['show_accordion'] = $show_accordion;
	$config_now['show_blocks'] = $show_blocks;
	$config_now['user_system'] = $user_system;
	$config_now['user_edit_data'] = $user_edit_data;
	$config_now['user_editor'] = $user_editor;
	$config_now['image_upload'] = $image_upload;
	$config_now['show_welcome'] = $show_welcome;
	$config_now['show_details'] = $show_details;

	$config->set($config_now);	
	
	// temp Verzeichnis anlegen, falls notwendig
	$tempdir = "modules/$module_name/$upload_path/temp";
	if ($image_upload == "1"){
		if(!file_exists($tempdir)){
			mkdir($tempdir);
		}
	stcMakeIndex($tempdir);
	}
}



/***
* stcWelcomeOff() 
* Ausblenden der WelcomeBox
***/
function stcWelcomeOff(){
	global $prefix, $module_name;
	$config = load_class('Config',$module_name);		
	$set_welcome_box['show_welcome'] = 0;
	$config->set($set_welcome_box);		
}



/***
* stcCategoryStatus($what, $cid)
* 
***/
function stcCategoryStatus($what, $cid){
	global $prefix, $module_name;
	
	$id = intval($cid);
	$status = intval($what);
	
	$qry = "update " . $prefix . "_structure_category set cat_active = '$status' where cat_id = '$id'";
	$result = sql_query($qry);
	header("Location: admin.php?op=$module_name&act=categorys");
	
}


/***
* stcSortingCategorys()
* 
***/
function stcSortingCategorys(){
	global $prefix;
	
	$pvs = mxAddSlashesForSQL($_POST);	
	foreach ($pvs['sort_id'] as $key => $value){
		// updaten
		$qry = "update " . $prefix . "_structure_category set cat_sorting = ".intval($pvs['sort_id'][$key])." where cat_id = '$key'";
		$result = sql_query($qry);
	}
	stcRepairSortCategorys();
}


/**
* stcRepairSortCategorys()
*
* Probleme mit Position loesen
* ist von pragmamx Team wurde nur angepasst 
*/
function stcRepairSortCategorys(){
    global $prefix;
    $newposition = 0;
    $lastpos = "xyz";
    $qry = "select cat_sorting,cat_id
                    from ${prefix}_structure_category
                    order by cat_sorting,cat_id";
    $result = sql_query($qry);
    while (list($old_pos, $id) = sql_fetch_row($result)) {
        
        $newposition++;
        if ($newposition != $old_pos) {
            $qry = "update ${prefix}_structure_category set cat_sorting = $newposition where cat_id=$id";
            sql_query($qry);
        }
    }
}



/***
* 
* 
***/
function stcDeleteCategorys($pvs){
	global $prefix, $module_name;
		
	// falls loschen = force war
	if(!is_array($pvs)){
		$var = $pvs;
		$pvs = array();
		$pvs['cid'][0]= $var;
	}

	foreach ($pvs['cid'] as $key => $value){
		$qry = "delete from " . $prefix . "_structure_category where (cat_id='$value' and cat_counter='0')";
		$result = sql_query($qry);
	}
}



/***
* 
* 
***/
function stcEditCategorysAllSave($pvs){
	global  $prefix, $module_name;
	foreach ($pvs['cat_name'] as $key => $value){
		$isstatus = $pvs['cat_status'][$key];
		// Update
		$qry = "update " . $prefix . "_structure_category set cat_name = '$value',cat_active = '$isstatus' where cat_id = '$key'";
		$result = sql_query($qry);
	}		
}


/***
* stcContentStatus($what, $cid, $cat_id)
* 
***/
function stcContentStatus($what, $cid, $cat_id){
	global $prefix, $module_name;
	
	$id = intval($cid);
	$status = intval($what);
	
	$qry = "update " . $prefix . "_structure_content set con_active = '$status' where con_id = '$id'";
	$result = sql_query($qry);
	header("Location: admin.php?op=$module_name&act=content&box=$cat_id");
	//header("Location: admin.php?op=$module_name&act=content");

}


/***
* stcDeleteContents($pvs)
* 
***/
function stcDeleteContents($pvs, $upload_path){
	global $prefix, $module_name;
	
	foreach ($pvs['cid'] as $key => $value){
		$result_content = sql_query("SELECT con_image FROM " . $prefix . "_structure_content where con_id='$value'");
		list($con_image) = sql_fetch_row($result_content);
		if(!empty($con_image)){
			// Bild loeschen
			unlink("modules/" . $module_name . "/" . $upload_path . "/" . $con_image . "");
		}
		$qry = "delete from " . $prefix . "_structure_content where con_id='$value' ";
		sql_query("update " . $prefix . "_structure_category cat_counter set cat_counter = cat_counter - 1 where cat_id=" . $pvs['box'] . "");  
		$result = sql_query($qry);
		// temp DB loeschen
		$qry = "delete from " . $prefix . "_structure_content_temp where con_id='$value' ";

		
	}	
}


/***
* stcPublishCategorys()
* Kategorien veroefentlichen
***/
function stcPublishCategorys(){
	global $prefix, $module_name;
	
	$pvs = mxAddSlashesForSQL($_POST);
	foreach ($pvs['cid'] as $key => $value){
		$qry = "update " . $prefix . "_structure_category set cat_active = '1' where cat_id = '$value'";
		$result = sql_query($qry);
	}
}


/***
* stcUnPublishCategorys()
* Kategorien veroefentlichen
***/
function stcUnPublishCategorys(){
	global $prefix, $module_name;
	
	$pvs = mxAddSlashesForSQL($_POST);
	foreach ($pvs['cid'] as $key => $value){
		$qry = "update " . $prefix . "_structure_category set cat_active = '0' where cat_id = '$value'";
		$result = sql_query($qry);
	}
}


/***
* stcContentMove()
* verschieben von Content
***/
function stcContentMove(){
	global $prefix, $module_name;
	$pvs = mxAddSlashesForSQL($_POST);

	// Fehler und wech
	if(!isset( $pvs['new_box'])){
		header("Location: admin.php?op=$module_name&&act=content&box=".$pvs['box']."");
	}
	
	foreach ($pvs['cid'] as $key => $value){
	
		$qry = "update " . $prefix . "_structure_content set con_category = '".$pvs['new_box']."' where con_id = '$value'";
		$result = sql_query($qry);
		
		// counter runter
		sql_query("update " . $prefix . "_structure_category cat_counter set cat_counter = cat_counter - 1 where cat_id=" . $pvs['box'] . "");  
		$result = sql_query($qry);

		// counter rauf
		sql_query("update " . $prefix . "_structure_category cat_counter set cat_counter = cat_counter + 1 where cat_id=" . $pvs['new_box'] . "");  
		$result = sql_query($qry);		
		
	}
	header("Location: admin.php?op=$module_name&&act=content&box=".$pvs['box']."");
}
?>