<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 636 $
 * $Author: PragmaMx $
 * $Date: 2022-10-24 07:41:49 +0200 (Mo, 24. Okt 2022) $
 */
 
defined('mxMainFileLoaded') or die('access denied');



/***
* imgModul()
* 
* zeigt Bild im Backendheader
***/
function imgModul(){
    global $module_name;
    $image = "structure2.png";
    
    return '<img src="modules/' . $module_name . '/images/' . $image . '" alt=""/>';
}


/***
* 
* 
***/
function checkUploadDir($upload_path){
	global $module_name;
	
	$checkdir = '<img src="modules/'.$module_name.'/images/status_on.png" style="width:18px" alt="" />';
		
	/* Verzeichnistest: ist Verzeichnis vorhanden und beschreibbar */
	$dir_test = "modules/$module_name/$upload_path";
	if(file_exists($dir_test)){
		$permsdir = decoct(fileperms($dir_test));
		$perms = substr($permsdir, -3);
		if ($perms != "777" || $dir_test == "") {
			$checkdir = '<img src="modules/'.$module_name.'/images/status_off.png" style="width:18px" alt="" />';
		}
	}else{
		$checkdir = '<img src="modules/'.$module_name.'/images/status_off.png" style="width:18px" alt="" />';	
	}
	
	return $checkdir;
}


/***
* 
* http://selfphp.de/code_snippets/code_snippet.php?id=145
***/
function cleanWhitespace($string) { 
    return trim( preg_replace('/\s+/', ' ', $string) ); 
} 


/***
* ShowSelectStatus($var, $var1)
* Selectboxen erstellen
***/
function ShowSelectStatus($cat_id, $cat_status){
	
	$cat_status = intval($cat_status);		
	$show_select = '<select name="cat_status['.$cat_id.']" size="1" style="width:90%">';
	
	switch ($cat_status){
		case "0":
		$show_select .= '<option selected="selected" class="current" value="0">' . _stc__DEACTIVE . '</option>';
		$show_select .= '<option value="1">' . _stc__ACTIVE . '</option>';
		break;
		
		case "1":
		$show_select .= '<option selected="selected" class="current" value="1">' . _stc__ACTIVE . '</option>';
		$show_select .= '<option value="0">' . _stc__DEACTIVE . '</option>';
		break;
	}
	$show_select .= '</select>';
	return $show_select;	
}


/***
* renameImgorDir($img_name)
* umschreiben von Verzeichnisnamen oder Bildnamen
*/
function renameImgorDir($img_name){
  // Verzeichnisnamen vorbehandeln und Vezeichnis anlegen
  $img_name = strtolower(str_replace(' ', '_', $img_name));
  $ersetzen = array( 'ä' => 'ae', 'ö' => 'oe', 'ü' => 'ue', 'ß' => 'ss', ' ' => '_', '__' => '_', '\\' => '-', '/' => '-' );
  $img_name = strtr( strtolower( $img_name ), $ersetzen );
  return $img_name;
}



// !Bookmark kann raus, aber einen Durchlauf warten
/***
* 
* 
***/
/*
function stcCheckUploadDir($dir){
	global $module_name;
	$upload_info=true;
	$dir_test = "modules/$module_name/$dir";
	if(file_exists($dir_test)){
		$permsdir = decoct(fileperms($dir_test));
		$perms = substr($permsdir, -3);
		if ($perms != "777" || $dir_test == "") {
			mxDebugFuncVars( $perms );
			$upload_info = false;
		}
	}else{
		$upload_info = false;

	}
	return $upload_info;
}
*/


/***
* 
* 
***/
function stcOnlyDeleteImage(){
	global $prefix, $module_name;
	
	$config = load_class('Config',$module_name);
	$stc_config=$config->get();
	
	$pvs = mxAddSlashesForSQL($_GET);	
	extract($pvs);
	
	// testen ob Bild im temp Ordner liegt

	$is_dir_img = strstr($image, "/", true);
	

	if($is_dir_img =="temp"){
		// DB Eintrag in Temp loschen
			$qry = "update " . $prefix . "_structure_content_temp set 
			con_image = '',
			con_hash =''
		where con_id = '$insertid'";
	}else{
	
		// Bild loeschen
		$deleteimg = 'modules/' . $module_name . '/' . $stc_config['upload_path'] . '/' . $image .'';
		unlink($deleteimg);	
	
		// DB updaten
		$qry = "update " . $prefix . "_structure_content set 
				con_image = '',
				con_hash=''
			where con_id = '$insertid'";
		$result = sql_query($qry);
	}
	header("Location: admin.php?op=$module_name&act=content_show&insertid=$insertid&box=$box");
}


/***
* stcDeleteImage()
* loeschen von Bild
***/
function stcDeleteImage(){
	global $prefix, $module_name;
		
	if(isset($_GET['tempflag'])){
		$tempflag = $_GET['tempflag'];
	}else{
		$tempflag ='';
	}

	if($tempflag == "1"){
		$settempflag = '_temp';
	}else{
		$settempflag ='';
	}
	// config laden
	$config = load_class('Config',$module_name);
	$stc_config=$config->get();
	
	$id = intval($_GET['img_id']);
	$result_content = sql_query("SELECT con_image FROM " . $prefix . "_structure_content".$settempflag." where con_id='$id'");
	list($con_image) = sql_fetch_row($result_content);
	
	$del_image = 'modules/' . $module_name . '/' . $stc_config['upload_path'] . '/' . $con_image . '';
	@unlink($del_image);

	$qry = "update " . $prefix . "_structure_content".$settempflag." set 
		con_image = ''
	where con_id = '$id'";

	$result = sql_query($qry);
}

/***
* stcSaveUserData()
* speichern von Userdaten
***/
function stcSaveUserData(){
	global $prefix, $module_name;

	$pvs = mxAddSlashesForSQL($_POST);
	extract($pvs);
	
	$admin_func = $con_function;
	
	// erste Kontrolle
	if(empty($con_title)){
		$error[] = _stc_ERROR_TITLE_EMPTY;
	}	
	if(empty($con_desc)){
		$error[] = _stc_ERROR_DESC_EMPTY;
	}
	// Abbruch wenn jetzt schon Fehle drin
	if(!empty($error)){
		mxSessionSetVar('stc_userdata_error', $error);
		header("Location: modules.php?name=$module_name&op=teamdata");
		exit;
	}
	$config = load_class('Config',$module_name);		
	$stc_config=$config->get();

	// vars
	$upload_path = 'modules/' . $module_name . '/' . $stc_config['upload_path']. '';
	$check_error = false;
	if(empty($delete_image_now)) $delete_image_now = '';
	if(empty($send_email)) $send_email = '0';

	// Userdaten aus normaler DB holen
	$result_is_content = sql_query("SELECT * FROM " . $prefix . "_structure_content where con_id='" . $pvs['con_id'] . "'");
	$content = sql_fetch_assoc($result_is_content);	
	
	if(!MX_IS_ADMIN){
		// temp holen
		$result_temp_content = sql_query("SELECT * FROM " . $prefix . "_structure_content_temp where con_id='" . $content['con_id'] . "'");
		$counter_temp = sql_num_rows($result_temp_content);
		if($counter_temp >= 1){
			$content = sql_fetch_assoc($result_temp_content);
			// Kontrollvars
			if(!empty( $content['con_image'] )){
				$delete_image_now = 1;
			}
			$send_email = '1';
		}	
	}
	// Testen ob Daten sich geaendert haben
	if(!stcCleanVars($content['con_desc'], $pvs['con_desc']) === true){
		$check_error = true;
	}
	if(!stcCleanVars($content['con_title'], $pvs['con_title']) === true){
		$check_error = true;
	}

	if(MX_IS_ADMIN){	
		if(!stcCleanVars($content['con_function'], $pvs['con_function']) === true){
			$check_error = true;
		}
	}
	
	// Eingabe-Daten sind geändert
	if($check_error){
		$content['con_title'] = $pvs['con_title'];
		$content['con_desc']  = $pvs['con_desc'];
	}
	if(!empty($_FILES['content_image']['name'])){
	// wenn Bild gekommen, upload, groesse aender und hash Wert ermitteln
	if (!array_key_exists('content_imgage',$_FILES)) {
		$checkupload = $_FILES['content_image']['name'];
		$checkerror  = $_FILES['content_image']['error'];
	}
	
	// jetzt Bild verarbeiten
	if(!empty($checkupload) and ($checkerror == "0")){
		$old_img = $content['con_image'];
		$old_hash = $content['con_hash'];
		
		$checkupload = renameImgorDir( $checkupload );	
		$checkupload = '__' . $con_id . '__' . $checkupload . '';
		$tmp_bild = $_FILES['content_image']['tmp_name'];
		
		// hier auf Admin testen und Pfade anpassen
		if(!MX_IS_ADMIN){
			move_uploaded_file($tmp_bild, "$upload_path/temp/$checkupload") ;
			stcImageChangeSize($checkupload, $dir='temp');
			$copy_temp_source = "$upload_path/temp/$checkupload";
			$copy_temp_target = "$upload_path/$checkupload";

			// Bild pruefen mit Hashwert
			$isnowhash = md5(file_get_contents( "$upload_path/temp/$checkupload" ));
		}
		if(MX_IS_ADMIN){
			move_uploaded_file($tmp_bild, "$upload_path/$checkupload") ;
			stcImageChangeSize($checkupload);
			// Bild pruefen mit Hashwert
			$isnowhash = md5(file_get_contents( "$upload_path/$checkupload" ));
		}
		
		// Bild ist neu
		if($content['con_hash'] != $isnowhash){
			// hier auf Admin testen und Pfade anpassen
			if(!MX_IS_ADMIN){
				$content['con_image'] = "temp/$checkupload";
				$content['con_hash'] = $isnowhash;
			}
			if(MX_IS_ADMIN){
				$content['con_image'] = "$checkupload";
				$content['con_hash'] = $isnowhash;
			}			
			// altes Bild loeschen wenn in Temp
			if($delete_image_now == "1"){
				@unlink("$upload_path/$old_img");
				// temp Bild kopieren
				copy ( $copy_temp_source, $copy_temp_target);
			}
			
			$check_error = true;
		}else{
			$content['con_image'] = $content['con_image'];
			$content['con_hash'] = $content['con_hash'];	
		}
	}	
	}
	if($check_error){
	
		// alle geänderten Daten und die die geich geblieben sind
		$con_id = $pvs['con_id'];
		if(!MX_IS_ADMIN){
			$con_active = '9';
		}		
		if(MX_IS_ADMIN){
			$con_active = $content['con_active'];
			$con_active = '1';
		}
		
		$con_category = $content['con_category'];
		$con_owner = $content['con_owner'];
		$con_title = $content['con_title'];
		$con_desc = $content['con_desc'];
		$con_image = $content['con_image'];
		$con_hash = $content['con_hash'];
		$con_function = $content['con_function'];
		if(MX_IS_ADMIN){
			$con_function = $admin_func;
		}
		// Daten in Temp speichern
		// hier auf Admin testen und Pfade anpassen
		if(!MX_IS_ADMIN){
			$set_db = 'structure_content_temp';
		}
		if(MX_IS_ADMIN){
			$set_db = 'structure_content';
		}		
		$copy = "REPLACE INTO " . $prefix . "_" . $set_db . " ( 
				con_id, con_active, con_category, con_owner, con_title, con_desc, con_image, con_hash, con_function 
				) VALUES (
				'$con_id','$con_active', '$con_category', '$con_owner', '$con_title', '$con_desc', '$con_image', '$con_hash', '$con_function'
				)";
			$resulta = sql_query($copy);
		
		/* Email an Admin */
		if(!MX_IS_ADMIN){
			if($send_email =="0"){
				$subject = _stc_EMAIL_SUBJECT;

				$is_modlink = 'admin.php?op='.$module_name.'&act=content_show&insertid='.$con_id.'&box='.$con_category.'';
				$link = 'http://'.$_SERVER['SERVER_NAME'].'/'.$is_modlink.'';
				$user = ''.$con_owner.' ';
				
				// Message
				$message  = sprintf( _stc_EMAIL_MSG, $user, $link);
				// send mail
				mxMail($GLOBALS['adminmail'], $subject, $message);
			}
		}
	}
}



/***
* stcCleanVars($var)
* @param mixed
* return true wenn gleich
***/
function stcCleanVars($var1, $var2){

	$var1 = str_replace("&nbsp;", "", preg_replace("/[\r\n]+[\s\t]*[\r\n]+/","", trim(Strip_tags($var1))));
	$var2 = str_replace("&nbsp;", "", preg_replace("/[\r\n]+[\s\t]*[\r\n]+/","", trim(Strip_tags($var2))));

	if($var1 == $var2){
		return true;
	}	
}



/***
* stcMakeBoxSetSession($box)
* Boxid in Session
***/
function stcMakeBoxSetSession($box){
	$box = intval($box);
	mxSessionSetVar('stc_box', $box);
}


/***
* stcImageChangeSize($filename, $dir)
* @param mixed Imagename
* @param mixid Dirname
***/
function stcImageChangeSize($filename, $dir=''){
	global $module_name, $module_name;
		
	$config = load_class('Config',$module_name);
	$stc_config=$config->get();
	
	// default ist 
	if(empty($dir)){
		$uplaod_dir = 'modules/' . $module_name . '/' . $stc_config['upload_path'] . '';
	}else{
		$uplaod_dir = 'modules/' . $module_name . '/' . $stc_config['upload_path'] . '/' . $dir . '';
	}
	#exit;

	//Bildgroesse
	$width = $stc_config['upload_width'];
	$height = $stc_config['upload_hight'];
	
	$path_to_image_directory = ''.$uplaod_dir.'/';
	$path_to_thumbs_directory = ''.$uplaod_dir.'/';
   
    if(preg_match('/[.](jpg)$/', $filename)) {
        $im = imagecreatefromjpeg($path_to_image_directory . $filename);
    } else if (preg_match('/[.](jpeg)$/', $filename)) {
         $im = imagecreatefromjpeg($path_to_image_directory . $filename);
    }else if (preg_match('/[.](gif)$/', $filename)) {
        $im = imagecreatefromgif($path_to_image_directory . $filename);
    } else if (preg_match('/[.](png)$/', $filename)) {
        $im = imagecreatefrompng($path_to_image_directory . $filename);
    }
     
    // Bildbreite ermitteln
    $ox = imagesx($im);
    // Bildhoehe ermitteln
    $oy = imagesy($im);
    
    // Groesse nur aendern, wenn Bild groesser ist

    if($ox > $width){
	    
		$nx = $width;
		$ny = $height;
	  		
	    $nm = imagecreatetruecolor($nx, $ny);
	     
	    imagecopyresized($nm, $im, 0,0,0,0,$nx,$ny,$ox,$oy);
	     
	    if(!file_exists($path_to_thumbs_directory)) {
	      if(!mkdir($path_to_thumbs_directory)) {
	           die("There was a problem. Please try again!");
			} 
		}
	    imagejpeg($nm, $path_to_thumbs_directory . $filename);
	}
	unset($im);
}



/***
* stcCopyContent()
* Kopieren Contenteintraege
***/
function stcCopyContent(){
	global $prefix, $module_name;
	
	$config = load_class('Config',$module_name);	
	$stc_config=$config->get();
	
	//vars
	$upload_path = 'modules/' . $module_name . '/' . $stc_config['upload_path'] . '';	
	
	foreach ($_POST['cid'] as $key => $value){
		
		// Daten holen welche kopiert werden sollen
		$result = sql_query("SELECT con_active, con_category, con_owner, con_title, con_desc, con_image, con_function FROM " . $prefix . "_structure_content where con_id=$value");
		list($con_active, $con_category, $con_owner, $con_title, $con_desc, $con_image_old, $con_function) = sql_fetch_row($result);

		// Test ob Systemuser, dann nicht kopieren
		$system_user = sql_query("SELECT uname FROM " . $prefix . "_users where uname='$con_owner'");
		$count_system_user = sql_num_rows($system_user);
		
		if($count_system_user == "0"){
			// testen ob in Temp-DB vorhande		
			$result_content_temp = sql_query("SELECT con_id FROM " . $prefix . "_structure_content_temp where con_id='$value'");
			$count_temp = sql_num_rows($result_content_temp);
	
			// Temp vorhanden
			if($count_temp == 0){
				
				$copy = "INSERT INTO " . $prefix . "_structure_content ( 
				con_id, con_active, con_category, con_owner, con_title, con_desc, con_image, con_function 
				) VALUES (
				'', '$con_active', '$con_category', '$con_owner', '$con_title', '$con_desc', '$con_image_old', '$con_function'
				)";
				$resulta = sql_query($copy);
				$insertid = sql_insert_id();
				$box = mxSessionGetVar('stc_box');
				sql_query("update " . $prefix . "_structure_category cat_counter set cat_counter = cat_counter + 1 where cat_id='$box'");
	
				// wenn Bild vorhanden, dann Bildnamen anpassen
				if(!empty($con_image_old)){
					$teile = explode("__", $con_image_old , 2);
	
					// Bildnamen neu
					$con_image = '__' . $insertid . '__' . $teile[1] . '';
					// Bildkopieren
					
					copy ("$upload_path/$con_image_old", "$upload_path/$con_image") ;
					$my_hash = md5(file_get_contents( "$upload_path/$con_image" ));
	
					//DB updaten
					$qry = "update ${prefix}_structure_content set con_image = '$con_image', con_hash='$my_hash' where con_id='$insertid'";
					sql_query($qry);
				}		
			}
		}
	}
}

/***
* stvDevelLogo
* Modifiziert die Logoausgabe
***/
function stcDevelLogo($modorg){
	
	global $prefix, $module_name;
	
	// default Text
	$title_text = 'by pragmaMx';
	
	if($modorg != $module_name){
		$title_text = '' . $module_name . ' based on ' . $modorg . ' ' . $title_text . '';	
	}
	
	$logoimg = '<img src="modules/'.$module_name.'/images/structure24.png" style="width:2em">';

	$logo ='<div class="align-right tiny"><a href="http://www.pragmaxm.org" target="_blank" title="' . $title_text . '">&nbsp;' . $logoimg . '&nbsp;</a>' .stc_Version(). '</div>';
	
	return $logo;
}


function stc_Version()
{
	global $prefix, $module_name;
	return mxcredit_shortinfo_string("modules/$module_name/setup.pmx.php");
}


/***
* stcCheckUploadImages($con_id)
* bereinigt Bildfehler in der DB und Verzeichnis
***/
function stcCheckUploadImages($con_id){
	global $prefix, $module_name;	
	
	$config = load_class('Config',$module_name);	
	$stc_config=$config->get();
	
	//vars
	$upload_path = 'modules/' . $module_name . '/' . $stc_config['upload_path'] . '';	
	$upload_path_temp = 'modules/' . $module_name . '/' . $stc_config['upload_path'] . '/temp';	
		
	$con_id = intval($con_id);
	// DB Bereich, hole Bildnamen
	$result = sql_query("SELECT con_image FROM " . $prefix . "_structure_content where con_id='$con_id'");
	list($con_image) = sql_fetch_row($result);
	// Bildname in DB, aber auch auf Platte
	if(!empty($con_image)){
		if(!file_exists("$upload_path/$con_image")){
			// ist nicht da, also DB Eintrag aufraeumen
			$qry = "update ${prefix}_structure_content set con_image = '', con_hash='' where con_id='$con_id'";
			sql_query($qry);
		}
	}
	

	
	// Bildname nicht vorhanden, vielleicht noch auf Platte
	if(empty($con_image)){
		
		function stcclear($con_id, $upload_path){
			// Durchsuche Verzeichnisse, Bildnamenstruktur ist bekannt
			$findMich = '__'.$con_id.'__';
			
			$ordner = $upload_path;
			$alledateien = scandir($ordner);
	
			foreach ($alledateien as $datei) {
				if(($datei != '.') && ($datei != '..')  && !is_dir(''.$ordner.'/' . $datei.'')) {
					$pos = strpos($datei, $findMich);
					if ($pos !== false) {
						// Bild zusammenbauen
						$del_image = "$upload_path/$datei";
						@unlink($del_image);
					}
				}
			}
		}

		stcclear($con_id, $upload_path);	
		
		$result_temp = sql_query("SELECT con_image FROM " . $prefix . "_structure_content_temp where con_id='$con_id'");
		list($con_image_temp) = sql_fetch_row($result_temp);
		if(empty($con_image_temp)){
			stcclear($con_id, $upload_path_temp);
		}
		
	}	
}


/***
 * stcMakeIndex($dirname)
 * @param mixed 
 * erstelle index.html
 */  
function stcMakeIndex($dirname){
	global $module_name;
	 
    $makeindex = "$dirname/index.html";
    if(!file_exists("$makeindex")){  
      fopen("$makeindex","w+"); 
      #fclose($makeindex);  
    }
}
?>
