<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 636 $
 * $Author: PragmaMx $
 * $Date: 2022-10-24 07:41:49 +0200 (Mo, 24. Okt 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(__DIR__);
pmxBase::set("plugins",1);
// Sprachfile
mxGetLangfile($module_name);

// Datenbank-Tabellen anlegen notfalls
include(PMX_MODULES_DIR . DS . $module_name . DS . "core/install.tabledef.php");
stcMakeTables();

// Funktionen einbinden
include(PMX_MODULES_DIR . DS . $module_name . DS . "includes/default_config.php");

// Config laden
$config = load_class('Config',$module_name);
$stc_config=$config->get();
$default_config = defaultConfig();
$stc_config = array_merge($default_config, $stc_config);

$index = $stc_config['show_blocks'];

if(empty($id)) $id = 0;
if(empty($op)) $op = '';

// Tu was
switch ($op) {

	case "teamdata":
		include("usertab.php");
		break;

	case "box":
		structureBox($id);
		break;

	case "detail":
		if($stc_config['show_details'] == "1"){
			structureDetail();
		}
		else{
			structureDefault();
		}
		break;

	case "teamdatasave":
		include_once("modules/$module_name/includes/functions.php");
		stcSaveUserData();
		include("usertab.php");
		break;
	case "delete_image":
		include_once("modules/$module_name/includes/functions.php");
		stcDeleteImage();
		include("usertab.php");
		break;	
  default:
    structureDefault();
    break;
}


/***
* structureDefault()
*
***/
function structureDefault(){
	global $prefix, $module_name, $stc_config, $bgcolor1;

	$info2 = $module_name;

	$default_config = defaultConfig();
	$stc_config = array_merge( $default_config, $stc_config);

	// umschreiben von Title
	if(!empty($stc_config['show_name'])){
		$info2 = $stc_config['show_name'];
	}

	// CSS wenn min css vorhanden nimm diese
	if(file_exists("modules/$module_name/style/style.min.css")){
		pmxHeader::add_style("modules/$module_name/style/style.min.css");
	}else{
		pmxHeader::add_style("modules/$module_name/style/style.css");
	}

	// Customstyle CSS
	if(file_exists("modules/$module_name/style/custom.style.css")){
		pmxHeader::add_style("modules/$module_name/style/custom.style.css");
	}

	// vorbereitend
	if(empty($before)) $before ='';

	// Kategorien
	$result = sql_query("SELECT cat_id, cat_name FROM " . $prefix . "_structure_category where (cat_active='1' and cat_counter!='0') order by cat_sorting asc");
	$count = sql_num_rows($result);

		while(list($structure_id, $structure_name) = sql_fetch_row($result)){
		$cat[$structure_id] = $structure_name;

		// jetzt den Content holen
		$result_content = sql_query("SELECT con_id, con_owner, con_title, con_desc, con_image, con_function FROM " . $prefix . "_structure_content where (con_category='$structure_id' AND con_active='1') order by con_nums asc");
		$count_content = sql_num_rows($result_content);
		$no_entry[$structure_id] = $count_content;
		while(list($con_id, $con_owner, $con_title, $con_desc, $con_image, $con_function) = sql_fetch_row($result_content)){
			$editlinkuser ='';
			$show_detail_imglink[$con_id]['start']= '<a href="modules.php?name=' . $module_name . '&amp;op=detail&amp;detailid=' . $con_id . '">';
			$show_detail_imglink['ende'] = '</a>';

			$content[$structure_id][$con_id]['con_id'] = $con_id;

			// Link zum bearbeiten
			if(MX_IS_USER){

				$userdata = mxGetUserData();
				if($userdata['uname'] == $con_owner){
					$editlinkuser = "<a title='" . _stc_EDIT_YOUR_DATA . "' href='modules.php?name=$module_name&amp;op=teamdata'><img src='modules/$module_name/images/edit.gif' style='width:15px' alt=''/></a>";
				}
			}


			// testen ob owner auch User ist
			
			$checkowner = mxGetUserDataFromUsername($con_owner);
			$title=$con_title;
			switch (TRUE)
			{
				case empty( $con_owner ):
				case !($checkowner):
					$title=$con_title;
				break;
				
				case ($con_owner == $checkowner['uname']):
					$title="$con_title  ( <a href='modules.php?name=Userinfo&amp;uname=$con_owner'> $con_owner</a> ) $editlinkuser";
				break;
			
			}
			$content[$structure_id][$con_id]['con_title']=$title;
			
			//mxDebugFuncVars($checkowner,$con_owner);
			/*
			if($checkowner and !empty( $con_owner ) and ($con_owner == $checkowner['uname'])){
				
				$content[$structure_id][$con_id]['con_title'] = "$con_title  ( <a href='modules.php?name=Userinfo&amp;uname=$con_owner'> $con_owner</a> ) $editlinkuser";
			}else{
				$content[$structure_id][$con_id]['con_title'] = "$con_title   ( $con_owner ) $editlinkuser";

			}
			*/
			// Bilder und Links entfernen
			//$pattern1="/<img.*>/Uis";
			//$pattern2="/<a.*\\/a>/Uis";
			//$con_desc=preg_replace($pattern1, '', $con_desc);
			//$con_desc=preg_replace($pattern2, '', $con_desc);
			//$con_desc = str_replace("&nbsp;", "", preg_replace("/[\r\n]+[\s\t]*[\r\n]+/","", trim(strip_tags($con_desc))));

			$con_desc = strip_tags($con_desc,"<p><br>");

			/* Text verkuerzen */
			//$con_desc = mxStripSlashes($con_desc);
			$con_desc = mxCutString($con_desc, $len = '80', $add = "...", $cutter = " ");

			$content[$structure_id][$con_id]['con_desc'] = $con_desc;
			$content[$structure_id][$con_id]['con_function'] = $con_function;
			// Bild checken
			if(!empty($con_image)){
				// Bild aus DB
				$is_image = 'modules/' . $module_name . '/' . $stc_config['upload_path']. '/' . $con_image . '';
				if(file_exists($is_image)){
					$content[$structure_id][$con_id]['con_image'] = 'modules/' . $module_name . '/' . $stc_config['upload_path']. '/' . $con_image . '';
				}else{
					$content[$structure_id][$con_id]['con_image'] = 'modules/' . $module_name . '/images/place_holder_m.png';
				}
			}else{
				$content[$structure_id][$con_id]['con_image'] = 'modules/' . $module_name . '/images/place_holder_m.png';
			}

			// Linkinfo zu Detailansicht
			$content[$structure_id][$con_id]['con_show_link'] = '<a href="modules.php?name=' . $module_name . '&amp;op=detail&amp;detailid=' . $con_id . '">' . _HREADMORE .'</a>';
		}
	}

	if(!empty( $stc_config['show_before'] )){
		$before = $stc_config['show_before'];
	}

	mxIncludeHeader();

	$show_accordion = $stc_config['show_accordion'];
	$columns=$stc_config['show_boxwidth'];
	//mxDebugFuncVars($bgcolor1);
	pmxHeader::add_style_code("ul.cards_content_list > li {flex-basis: ".$columns."px !important; background-color: ".$bgcolor1.";}");
	
	if($show_accordion == "1"){
		pmxHeader::add_script_code('
			$(function() {
				$(document).ready(function() {
					$("#accordion").accordion({ heightStyle: "content" });
				});
			});
		');
		pmxHeader::add_jquery(
		'ui/jquery-ui-pmx-core.min.js',
		'ui/jquery.ui.accordion.min.js'	
		);
	}

	$show_detail = $stc_config['show_details'];
	/*
     * Template
     */
    $template = load_class('Template');
    $template->init_path(__FILE__);

	// Template Design
	$show_template = $stc_config['show_design'];
	

	$css = array("path"=> $show_template);

	if($count >= "1"){

	    /* hier die Ausgabefelder angeben */
	    $template->assign(compact('info2','before','module_name','cat','content','show_accordion','no_entry','css','show_detail', 'show_detail_imglink'));

		// foreach oder?

		/* Template-Vars als default setzten und notfalls ueberschreiben wenn nicht vorhanden ist */
		$is_now_template = "design/$show_template/index.html";
	}else{
		  /* hier die Ausgabefelder angeben */
	    $template->assign(compact('info2'));

		/* Template-Vars als default setzten und notfalls ueberschreiben wenn nicht vorhanden ist */
		$is_now_template = "design/$show_template/blank.html";

	}

	
	$template->display($is_now_template);
	echo "<br/>";
	mxIncludeFooter();
}



/***
* structureDetail()
*
***/
function structureDetail(){
	global $prefix, $module_name, $stc_config;
	$con_id = intval($_GET['detailid']);

	$info2 = $module_name;

	// umschreiben von Title
	if(!empty($stc_config['show_name'])){
		$info2 = $stc_config['show_name'];
	}

	// CSS wenn min css vorhanden nimm diese
	if(file_exists("modules/$module_name/style/style.min.css")){
		pmxHeader::add_style("modules/$module_name/style/style.min.css");
	}else{
		pmxHeader::add_style("modules/$module_name/style/style.css");
	}
	// Customstyle CSS
	if(file_exists("modules/$module_name/style/custom.style.css")){
		pmxHeader::add_style("modules/$module_name/style/custom.style.css");
	}

	// Daten holen
	$result_content = sql_query("SELECT con_id, con_owner, con_category, con_title, con_desc, con_image, con_function FROM " . $prefix . "_structure_content where con_id='$con_id'");
	//while(list($con_id, $con_title, $con_desc, $con_image) = sql_fetch_row($result_content)){
	$content = array();
	while(list($con_id, $con_owner, $con_category, $con_title, $con_desc, $con_image, $con_function) = sql_fetch_row($result_content)){

		// testen ob owner auch User ist
		$checkowner = mxGetUserDataFromUsername($con_owner);

		if(!empty( $con_owner ) and ($con_owner == $checkowner['uname'])){
			$content['con_title'] = "$con_title  ( <a href='modules.php?name=Userinfo&uname=$con_owner'> $con_owner</a> )";
		}else{
			$content['con_title'] = "$con_title    $con_owner ";
		}

		$content['con_function'] = $con_function;
		if(!empty($con_image)){
			$is_image = 'modules/' . $module_name . '/' . $stc_config['upload_path']. '/' . $con_image . '';
			if(file_exists($is_image)){
				$content['con_image'] = 'modules/' . $module_name . '/' . $stc_config['upload_path']. '/' . $con_image . '';
			}else{
				$content['con_image'] = 'modules/' . $module_name . '/images/place_holder_m.png';
			}
		}else{
			$content['con_image'] = 'modules/' . $module_name . '/images/place_holder_m.png';
		}

		$result = sql_query("SELECT cat_name FROM " . $prefix . "_structure_category where cat_id='$con_category'");
		list($cat_name) = sql_fetch_row($result);
		$content['con_title_desc'] = $cat_name;

		if(!empty($con_function)){
			$content['con_desc'] = "<div class='function'>Position: $con_function</div> $con_desc";
		}else{
			$content['con_desc'] = $con_desc;
		}
	}

	/*
     * Template
     */
    $template = load_class('Template');
    $template->init_path(__FILE__);

	// Template Design
	$show_template = $stc_config['show_design'];
	$css = array("path"=> $show_template);
    /* hier die Ausgabefelder angeben */
    $template->assign(compact('info2', 'module_name','content','css'));

	include_once("header.php");
		$template->display("design/$show_template/details.html");
		echo "<br/>";
	include_once("footer.php");

}

/***
* structureDefault()
*
***/
function structureBox($id=0){
	global $prefix, $module_name, $stc_config;

	$info2 = $module_name;

	$default_config = defaultConfig();
	$stc_config = array_merge( $default_config, $stc_config);

	// umschreiben von Title
	if(!empty($stc_config['show_name'])){
		$info2 = $stc_config['show_name'];
	}

	// CSS wenn min css vorhanden nimm diese
	if(file_exists("modules/$module_name/style/style.min.css")){
		pmxHeader::add_style("modules/$module_name/style/style.min.css");
	}else{
		pmxHeader::add_style("modules/$module_name/style/style.css");
	}

	// Customstyle CSS
	if(file_exists("modules/$module_name/style/custom.style.css")){
		pmxHeader::add_style("modules/$module_name/style/custom.style.css");
	}

	// vorbereitend
	if(empty($before)) $before ='';
	$id=intval($id);

	// Kategorien
	$result = sql_query("SELECT cat_id, cat_name FROM " . $prefix . "_structure_category where cat_active='1' and cat_counter!='0' and cat_id=$id");
	$count = sql_num_rows($result);

		while(list($structure_id, $structure_name) = sql_fetch_row($result)){
		$cat[$structure_id] = $structure_name;

		// jetzt den Content holen
		$result_content = sql_query("SELECT con_id, con_owner, con_title, con_desc, con_image, con_function FROM " . $prefix . "_structure_content where (con_category='$structure_id' AND con_active='1') order by con_nums asc");
		$count_content = sql_num_rows($result_content);
		$no_entry[$structure_id] = $count_content;
		while(list($con_id, $con_owner, $con_title, $con_desc, $con_image, $con_function) = sql_fetch_row($result_content)){
			$editlinkuser ='';
			$show_detail_imglink[$con_id]['start']= '<a href="modules.php?name=' . $module_name . '&amp;op=detail&amp;detailid=' . $con_id . '">';
			$show_detail_imglink['ende'] = '</a>';

			$content[$structure_id][$con_id]['con_id'] = $con_id;

			// Link zum bearbeiten
			if(MX_IS_USER){

				$userdata = mxGetUserData();
				if($userdata['uname'] == $con_owner){
					$editlinkuser = "<a title='" . _stc_EDIT_YOUR_DATA . "' href='modules.php?name=$module_name&amp;op=teamdata'><img src='modules/$module_name/images/edit.gif' style='width:15px' alt=''/></a>";
				}
			}


			// testen ob owner auch User ist
			
			$checkowner = mxGetUserDataFromUsername($con_owner);
			$title=$con_title;
			switch (TRUE)
			{
				case empty( $con_owner ):
				case !($checkowner):
					$title=$con_title;
				break;
				
				case ($con_owner == $checkowner['uname']):
					$title="$con_title  ( <a href='modules.php?name=Userinfo&amp;uname=$con_owner'> $con_owner</a> ) $editlinkuser";
				break;
			
			}
			$content[$structure_id][$con_id]['con_title']=$title;
			
			//mxDebugFuncVars($checkowner,$con_owner);
			/*
			if($checkowner and !empty( $con_owner ) and ($con_owner == $checkowner['uname'])){
				
				$content[$structure_id][$con_id]['con_title'] = "$con_title  ( <a href='modules.php?name=Userinfo&amp;uname=$con_owner'> $con_owner</a> ) $editlinkuser";
			}else{
				$content[$structure_id][$con_id]['con_title'] = "$con_title   ( $con_owner ) $editlinkuser";

			}
			*/
			// Bilder und Links entfernen
			//$pattern1="/<img.*>/Uis";
			//$pattern2="/<a.*\\/a>/Uis";
			//$con_desc=preg_replace($pattern1, '', $con_desc);
			//$con_desc=preg_replace($pattern2, '', $con_desc);
			//$con_desc = str_replace("&nbsp;", "", preg_replace("/[\r\n]+[\s\t]*[\r\n]+/","", trim(strip_tags($con_desc))));

			$con_desc = strip_tags($con_desc,"<p><br>");
			/* Text verkuerzen */
			//$con_desc = mxStripSlashes($con_desc);
			$con_desc = mxCutString($con_desc, $len = '80', $add = "...", $cutter = " ");

			$content[$structure_id][$con_id]['con_desc'] = $con_desc;
			$content[$structure_id][$con_id]['con_function'] = $con_function;
			// Bild checken
			if(!empty($con_image)){
				// Bild aus DB
				$is_image = 'modules/' . $module_name . '/' . $stc_config['upload_path']. '/' . $con_image . '';
				if(file_exists($is_image)){
					$content[$structure_id][$con_id]['con_image'] = 'modules/' . $module_name . '/' . $stc_config['upload_path']. '/' . $con_image . '';
				}else{
					$content[$structure_id][$con_id]['con_image'] = 'modules/' . $module_name . '/images/place_holder_m.png';
				}
			}else{
				$content[$structure_id][$con_id]['con_image'] = 'modules/' . $module_name . '/images/place_holder_m.png';
			}

			// Linkinfo zu Detailansicht
			$content[$structure_id][$con_id]['con_show_link'] = '<a href="modules.php?name=' . $module_name . '&amp;op=detail&amp;detailid=' . $con_id . '">' . _HREADMORE .'</a>';
		}
	}

	if(!empty( $stc_config['show_before'] )){
		$before = $stc_config['show_before'];
	}

	$show_accordion = 0; // nur Bugfix

	$show_detail = $stc_config['show_details'];
	$columns=$stc_config['show_boxwidth'];
	pmxHeader::add_style_code("ul.cards_content_list > li {flex-basis: ".$columns."px !important;}");
	/*
     * Template
     */
    $template = load_class('Template');
    $template->init_path(__FILE__);

	// Template Design
	$show_template = $stc_config['show_design'];

	$css = array("path"=> $show_template);

	if($count >= "1"){

	    /* hier die Ausgabefelder angeben */
	    $template->assign(compact('info2','before','module_name','cat','content','show_accordion','no_entry','css','show_detail', 'show_detail_imglink'));

		// foreach oder?

		/* Template-Vars als default setzten und notfalls ueberschreiben wenn nicht vorhanden ist */
		$is_now_template = "design/$show_template/index.html";
	}else{
		  /* hier die Ausgabefelder angeben */
	    $template->assign(compact('info2'));

		/* Template-Vars als default setzten und notfalls ueberschreiben wenn nicht vorhanden ist */
		$is_now_template = "design/$show_template/blank.html";

	}

	mxIncludeHeader();
	
		$template->display($is_now_template);
		
		echo "<div class=\"block align-center\" ><a href=\"".modulesURL($module_name)."\" title=\""._stc_BACKTO_OVERVIEW."\">"._stc_BACKTO_OVERVIEW."</a></div>";
		echo "<br/>";
	mxIncludeFooter();
}

function struktureGetTemplate()
{	
	global $prefix, $module_name, $stc_config;
	
	$template= $stc_config['show_design'];
	if (file_exists("modules/".$module_name."/templates/design/".$template."/blank.html"))
		return $template;
	elseif (!file_exists("modules/".$module_name."/templates/design/_blankDesign/blank.html")) {
		trigger_error("Design not found");
	}
	return "_blankDesign";
}
?>
