<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 10 $
 * $Author: PragmaMx $
 * $Date: 2018-09-30 15:43:26 +0200 (So, 30. Sep 2018) $
 */
 
defined('mxMainFileLoaded') or die('access denied');
  
if (!mxGetAdminPref("radminsuper")) {
    mxErrorScreen("Access Denied");
    die();
} 

$module_name = basename(__DIR__);

// Languagefile im Moment noch im Modulverzeichnis
// Bild ist auch noch im Modulverzeichnis modules/...../images/uninstaller.png
mxGetLangfile($module_name,"uninstall.lang-*.php");


/***
* Default Variablen des Modules
* @param modulename, temp_dir, db-tables_one, db-tables_two etc.
*
* modulename = Modulename 
* tempdir = immer zum root z.B. ("modules/$module_name/upload/temp") ohne Slash am Ende 
* db_ die verschiedenen Datenbanktabellen ohne Unterstrich!!
***/
$delete_vars = array(
	"modulename"=>$module_name, 
	"tempdir"=>"", // muss erhalten bleiben
	"db_1"=>"structure_category",
	"db_2"=>"structure_content",
	"db_3"=>"structure_content_temp"
	);

// !Bookmark tempdir sollte noch gefiltert werden Backslashes, Leerzeichen entfernen

// Vars
if(empty($act)) $act = '';

// Tue was
switch ($act) {
	case "delete_data":
	deleteNow();
	break;

	default:
	unInstall($delete_vars);
	break;	
}	


function unInstall($delete_vars){
	global $prefix, $module_name;

	// config laden
	$config = load_class('Config',$module_name);	
	$stc_config=$config->get();

	pmxHeader::add_script_code('
		function senden_aktiv(){
			if ( document.form_name.yes_i_will.checked == true ){
				document.form_name.senden.disabled = false;
			}else{
				document.form_name.senden.disabled = true;
			}
		}');

	$tbl = '<table class="list full">
				<tr> 
					<th width="5%" align="center"></th>  
					<th width="65">' . _UNINSTALLER_TYPE . '</th>	
					<th width="30">' . _UNINSTALLER_TITLE . '</th>';
	
	// setzen von CCS Klassen und Icon
	$colClass = array("alternate","alternate-b");
	$a = count($colClass);
	$i ='0';
				
	foreach($delete_vars as $key => $value){
		$set_type = '';
		// nur einmal machen
		if($i == "0"){
			$value = strtolower($value);
			$set_type = _UNINSTALLER_SYSCONFIG;
			$checked = 'checked="checked"';
			
		}
		if($i == "1"){
			$set_type = _UNINSTALLER_TEMPDIR;
			if(empty($value)){
				$checked ='style="cursor:not-allowed" disabled="disabled"';
			}
		}
		if($i >= "2"){
			$set_type = _UNINSTALLER_DB_TABLE;
			$checked = 'checked="checked"';

		}		
		
		$tbl .= '<tr class="' . $colClass[$a%count($colClass)] . '">';	
		$tbl .= '<td><input type="checkbox" '. $checked  . ' name="cdi['.$key.']" value="' . $value . '"></td>';
		$tbl .= '<td>' . $set_type . '</td>';
		$tbl .= '<td>' . $value . '</td>';
		$tbl .= '</tr>';		
		$i++;
		$a++;
	}

			
	$tbl .= '</table>';
	
	$submit = '<div>&nbsp;</div>
				<input type="checkbox" name="yes_i_will" onclick="senden_aktiv();"> ' . _UNINSTALLER_YES_I_WILL . '
		    	<div>&nbsp;</div>
		    	<input type="submit" name="senden" value="' . _UNINSTALLER_BUTTON . '" disabled>';

	
	include_once('header.php');

	echo '<form name="form_name" action="modules.php?name='.$module_name.'&file=uninstall" method="post">';
	echo '<input type="hidden" name="act" value="delete_data" />';

	echo '<h2> ' . sprintf( _UNINSTALLER,$module_name).'</h2>';
	
	echo '<div class="note" style="text-align:left">';
		echo '<div style="margin:5px 50px 50px 50px;width:80%"><img style="margin:5px 50px 50px 50px;float:left" src="modules/' . $module_name . '/images/uninstaller.png" alt=""/>' . _UNINSTALLER_WARNING. '</div>';
	
		echo '<div style="clear: left;"></div>';
		
		echo '<div style="text-align:center">';
			echo '<strong>' . _UNINSTALLER_SELECT_MSG . '</strong>';
			echo $tbl;
			echo $submit;
		echo '</div>';
	echo '</div>';

	echo '</form>';
	echo '<div style="text-align:right">'.pmxDevelLogo() . '</div>';	
	include_once('footer.php');
}


function deleteNow(){
	global $prefix, $module_name;
	
	foreach($_POST['cdi'] as $key => $value){
		
		switch ($key){
			case "modulename":
				// Sysconfig loeschen
				if(!empty($value)){
					$qry = "delete from " . $prefix . "_sys_config where section ='$value'";
					$result = sql_query($qry); 
				}
				break;
			
			case "tempdir":
				if(!empty($value)){
					loeschen($value);
				}
				break;
			
			default:
				$qry = "DROP TABLE IF EXISTS  " . $prefix . "_" . $value . "";
				$result = sql_query($qry);

				break;		
		}
		
	}
	
	include_once('header.php');
	echo '<h2> ' . sprintf( _UNINSTALLER,$module_name).'</h2>';
		echo '<div class="note" style="text-align:left">';
		echo '<div style="margin:5px 50px 50px 50px;width:80%"><img style="margin:5px 50px 50px 50px;float:left" src="modules/' . $module_name . '/images/uninstaller.png" alt=""/>' . _UNINSTALLER_SUCCESSFUL . '';
		echo '<div>&nbsp;</div>';
		echo '<div>' . _UNINSTALLER_THANKS . '</div>';
		echo '</div></div>';

		
	echo '<div style="text-align:right">'.pmxDevelLogo() . '</div>';	
	include_once('footer.php');
	exit;
}




/** 
 * Löschen eines kompletten Directorys inklusive 
 * vorhandenen Files. 
 * 
 * @param string $path  
 * @return boolean 
 *
 * Quelle:https://www.php.de/forum/webentwicklung/php-einsteiger/php-tipps-2009/64582-erledigt-ein-verzeichnis-mit-inhalt-löschen
 * jedoch Fehlerbereinigt, einige Kammern falsch
 */ 
function loeschen($path) { 
    if (is_dir($path) === true) { 
        $files = array_diff(scandir($path), array('.', '..')); 
         
        // Durch die vorhandenen Dateien laufen 
        foreach ($files as $file) { 
          loeschen(realpath($path) . '/' . $file); 
        } 
        return rmdir($path); 
    } 
     
    // Datei entfernen 
    else if (is_file($path) === true) { 
        return unlink($path); 
    } 
    return false; 	  
}

?>