<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 638 $
 * $Author: PragmaMx $
 * $Date: 2022-11-13 17:58:50 +0100 (So, 13. Nov 2022) $
 */


defined('mxMainFileLoaded') or die('access denied');
$module_name= basename(dirname(__FILE__));
	
/* eventuelle eigene Funktionen einbinden */
include_once(PMX_MODULES_DIR . DS . $module_name . DS . "includes/functions.php");


mxGetLangfile($module_name);
$index=0;
pmxBase::set("index",0);
userbereich();

function userbereich() {
	global $prefix, $module_name, $bgcolor1, $bgcolor2, $bgcolor3;
	// aktuellen User ermitteln
	
	// config laden
	$config = load_class('Config',$module_name);
	$stc_config=$config->get();
	
	$user=mxGetUserData();
	if (!MX_IS_USER) mxErrorScreen(_GROUPRESTRICTEDAREA);	
	
	pmxHeader::add_style("modules/$module_name/style/style.css");
	
	// zur Sicherheit mal ausgabepuffer starten
	ob_start();
	
	
	// Vars setzten und auswerten
	if(empty($delete_img_button)) $delete_img_button = '';
	if(empty($show_warning)) $show_warning = '';
	if(empty($acces_input)) $acces_input = '';
	$show_img = '<img class="usertab" src="modules/' . $module_name . '/images/place_holder_m.png">';	
	$imagedir = 'modules/' . $module_name . '/' . $stc_config['upload_path'] . '';
	$teaminfo = '<div class="success">Datenbearbeitung nicht zu gelassen!</div>';
	$tempflag = '';
	// !Bookmark hier noch Text aendern, so das keine 0 drin ist sondern das die Hoehe berechnet wird
	// Upload Infomsg
	$width = $stc_config['upload_width'];
	$hight = $stc_config['upload_hight'];		

	// Userdaten aus normaler DB holen
	$result_is_content = sql_query("SELECT * FROM " . $prefix . "_structure_content where con_owner='" . $user['uname'] . "'");
	$content = sql_fetch_assoc($result_is_content);	

	$result_temp_content = sql_query("SELECT * FROM " . $prefix . "_structure_content_temp where con_id='" . $content['con_id'] . "'");
	$counter_temp = sql_num_rows($result_temp_content);
	if($counter_temp >= 1){
		$content = sql_fetch_assoc($result_temp_content);
		$show_warning = '<div class="warning">' . _stc_WAITING_ACCESS . '</div>';
		$tempflag = "&tempflag=1";
	}	

	
	// Bilder Fehler und Errors beheben
	stcCheckUploadImages($content['con_id']);

	// daten wieder zurück schreiben, da der Rest ja funktioniert hat
	$con_id = 	$content['con_id'];
	$con_title = $content['con_title'];
	$con_function = $content['con_function'];
	$con_desc = $content['con_desc'];
	$con_image = $content['con_image'];
	// Editor auswerten
	if($stc_config['user_editor'] == "1"){
		$editor = load_class('Textarea', array('name' => 'con_desc', 'value' => $con_desc, 'width'=> '100%','height' => '150','toolbar'=>'reduced') );
		$show_editor = $editor->getHtml();
	}else{
		$show_editor = '<textarea  class="taclass" style="width:100%; hight:250px" cols="" rows=""  name="con_desc">' . $con_desc . '</textarea>';
	}
	
	// Button false
	$show_button = false;
	// Bild ueberschreiben wenn vorhande		
	if(!empty($con_image)){
		if(file_exists("$imagedir/$con_image")){
			$show_img = '<img class="usertab" src="' . $imagedir . '/' . $con_image . '">';
			$show_button = true;
			
		}else{
			$show_img = '<img class="usertab" src="modules/' . $module_name . '/images/place_holder_m.png">';	
		}	
	}	
	
	if($show_button){
		$delete_img_button = '<a class="button" href="modules.php?name='.$module_name.'&op=delete_image&img_id='.$con_id.''.$tempflag.'">' . _stc_DELETE_IMAGE_BUTTON . '</a>';
	}
	
	
	
	
	if(!MX_IS_ADMIN){
		$acces_input = 'style="cursor:not-allowed" readonly="readonly"';
	}	

	if($stc_config['user_edit_data'] =="1"){	
		$warning  = $show_warning;
		$team_msg = '';
		$form_start = '<form enctype="multipart/form-data" action="modules.php?name=' . $module_name . '&op=teamdatasave" method="post">';
		$form_hidden = '<input type="hidden" name="con_id" value="' . $con_id . '">';	
		
		// Tabellendaten
		$showtitle = '<input type="text" name="con_title" value="'.$con_title.'" maxlength="60" size="50"  >';
		$showfunction = '<input type="text" name="con_function" value="'.$con_function.'" maxlength="60" size="50" ' . $acces_input . ' >';
		$showedit = $show_editor;
		$showimage = '<tr>
						<td style="text-align:center;" class="bgcolor2" ><strong>' . _stc_UPLOADED_IMAGE . '</strong><br>' . $show_img . '' . $delete_img_button . '<div>&nbsp;</div></td>
						<td valign="top" class="bgcolor3"><strong>' . _stc_UPLOAD_EDIT . '</strong><div>&nbsp;</div><div>' . sprintf(_stc_UPLOAD_INFO, $width, $hight) . '</div>
						<div style="height: 5em">&nbsp;</div><input type="file" name="content_image" size="60" maxlength="255" ></td>
					</tr>';
		if(!MX_IS_ADMIN){
		$showwarn = '<tr>
								<td style="text-align:center;" class="bgcolor3" colspan="2" ><div class="warning">' . _stc_ACCESS_MSG . '</div></td>
							</tr>';
		}else {
			$showwarn ='';
		}
		$show_submit ='<tr>
							<td style="text-align:center;" class="bgcolor2" >&nbsp;</td>
							<td valign="top" class="bgcolor3"><input class="button" type="submit" value="' . _stc__EDITDATA_BUTTON . '"></td>
						</tr>';
		
		// Ende
		$form_ende = '</form>';
	
	}
		
	// Ansicht so überschreiben, dass kein bearbeiten geht
	if($stc_config['user_edit_data'] =="0"){
		$warning = '';
		$team_msg = $teaminfo;
		$form_start = '';
		$form_hidden = '';
		// Tabellendaten
		$showtitle = $con_title;
		$showfunction = $con_function;
		$showedit = '<div> ' . $con_desc . '</div>';
		$showimage = '<tr>
						<td style="text-align:left;vertical-align:top" class="bgcolor2" ><strong>' . _stc_UPLOADED_IMAGE . '</strong></td>
						<td valign="top" class="bgcolor3"><br>' . $show_img . '<div>&nbsp;</div></td>
					</tr>';
		$showwarn = '';
		//Ende
		$form_ende = '';
	}
	
	// hier noch den Back Button einbinden
	$back_to_modul = '
	
	<table class="full">
  <tr>
    <td style="width:80%"><h3>'._stc_TAB.'</h3></td>
    <td style="width:20%;text-align:right;"><a title="' . _stc_BACKTO_MODULE . '" href="modules.php?name=' . $module_name . '"><img src="modules/' . $module_name . '/images/structure24.png"  alt="" /></a></td>
  </tr>
</table>';
	
	
	
	// Ausgabe vorbereiten

	$table = '<table class="bgcolor1 " cellspacing="3" cellpadding="5" width="100%" >
				<tr>
					<td style="width:20%"" class="bgcolor2" ><strong>' . _stc__TITLE . '</strong></td>
					<td class="bgcolor3" height="30px">' . $showtitle . '</td>
				</tr>
				<tr>
					<td  class="bgcolor2" ><strong>' . _stc__FUNCTION . '</strong></td>
					<td class="bgcolor3" height="30px">' . $showfunction . '</td>
				</tr>
				 <tr >
				 	<td class="bgcolor3" colspan="2" ><strong>' . _stc__DESCIPTION . '</strong>' . $showedit . '</td>
				</tr>';
				
		if($stc_config['image_upload'] == "1"){
			$table .= $showimage;
		}	
	$table .= $showwarn;
	$table .= $show_submit;
	$table .= '</table>';
	// Ausgabe Ende

	/* Daten anzeigen */	
	// Fehlermeldungen aus Session
	$post_error_msg = mxSessionGetVar('stc_userdata_error');	

	if(empty($post_error_msg)){	
		echo $warning ;
	}

	echo $team_msg;
	echo $form_start;
	echo $form_hidden;
	
	if(!empty($post_error_msg)){	
		echo '<div class="warning">';
		echo '<div style="text-align: left;"><h2>' . _stc_ERROR . '</h2><strong>' . _stc_ERROR_WRITE . '</strong><ul><li>' . implode('</li><li>', $post_error_msg) . '</li></ul></div>';
		echo '</div><div>&nbsp;</div>';
	}
		
	// Fehlermeldung beim speichern ist ausgewertet, loeschen
	mxSessionDelVar('stc_userdata_error');
	
	echo $table;
	echo $form_ende;
	/* Daten anzeigen Ende */

	// Hier den ganzen Ausgabepuffer holen und in $out speichern
	$out = ob_get_clean();

	/* Userdaten holen */
	$userdata = mxGetUserData();
	
	/* Userfunktionen einbinden */
	require_once(PMX_SYSTEM_DIR . DS . 'mx_userfunctions.php');
	
	/* hier wird der eigentliche Tab erstellt, mit der Klasse pmxUserPage() */
	$view = new pmxUserPage($userdata);
	
	/* Tabname muss mit der Definition fuer 'caption' in der user.navbar.php Ã¼bereinstimmen */
	$view->tabname = _stc_TAB;
	
	/* Beliebiger Text am Anfang des Tabs (optional) wenn nicht gebraucht, dann Leer definieren */
	$view->subtitle = $back_to_modul;
	
	/* hier kommt jezt die Ausgabe aus der Variablen in den Tab.*/
	$view->show($out);
}
?>
